<< problem 227 - The Chase | Fibonacci Words - problem 230 >> |
Problem 229: Four Representations using Squares
(see projecteuler.net/problem=229)
Consider the number 3600. It is very special, because
3600 = 48^2 + 36^2
3600 = 20^2 + 2 * 40^2
3600 = 30^2 + 3 * 30^2
3600 = 45^2 + 7 * 15^2
Similarly, we find that 88201 = 99^2 + 280^2 = 287^2 + 2 * 54^2 = 283^2 + 3 * 52^2 = 197^2 + 7 * 84^2.
In 1747, Euler proved which numbers are representable as a sum of two squares.
We are interested in the numbers n which admit representations of all of the following four types:
n = a_1^2 + b_1^2
n = a_2^2 + 2 b_2^2
n = a_3^2 + 3 b_3^2
n = a_7^2 + 7 b_7^2,
where the a_k and b_k are positive integers.
There are 75373 such numbers that do not exceed 10^7.
How many such numbers are there that do not exceed 2 * 10^9?
My Algorithm
My program works similar to a prime sieve:
Two nested loops generate all a
and b
and then mark all x = a^2 + k * b^2 (where k \in { 1,2,3,7 }).
It's possible that there are multiple combinations of a and b for the same k.
Therefore I use four bits because there are four different k.
The naive approach needs 2 GByte RAM. A substantial part of my code is dedicated to process all x in a rolling fashion:
Iterate over all a and then over all b but restrict b in such a way that x = a^2 + k * b^2 is in a certain range.
My current design processes 1 million x at once - which requires 1 MByte RAM and fits nicely in my CPU L2 cache.
The four arrays b1
, b2
, b3
and b7
store the minimum b
for each a
for the current slice / range.
Alternative Approaches
Some people came up with smart insights regarding special properties of the matching numbers modulo 168.
Apparantly you can solve the problem in 1 second. Mine needs about 11 seconds.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho 10000000 | ./229
Output:
Note: the original problem's input 2000000000
cannot be entered
because just copying results is a soft skill reserved for idiots.
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too.
#include <iostream>
#include <vector>
#include <cmath>
const unsigned int SliceSize = 1000*1000;
// bitmasks of for a^2 + k * b^2
const unsigned char One = 1 << 0; // k = 1
const unsigned char Two = 1 << 1; // k = 2
const unsigned char Three = 1 << 2; // k = 3
const unsigned char Seven = 1 << 3; // k = 7
// every matching number must have all four bits set
const unsigned char All = One | Two | Three | Seven;
int main()
{
unsigned int limit = 2*1000*1000*1000;
std::cin >> limit;
// how many numbers match the criteria
unsigned int count = 0;
// contains bitmasks for the current slice
std::vector<unsigned char> used(SliceSize, 0);
// store start values of b for each factor k=1,2,3,7
unsigned int maxA = sqrt(limit);
std::vector<unsigned int> b1(maxA + 1, 1);
std::vector<unsigned int> b2(maxA + 1, 1);
std::vector<unsigned int> b3(maxA + 1, 1);
std::vector<unsigned int> b7(maxA + 1, 1);
// split into slices
unsigned int from = 0;
while (from < limit)
{
// size of current slice
unsigned int to = from + SliceSize;
if (to > limit)
to = limit;
// process all a and b where a^2+kb^2 is within the current slice
for (unsigned int a = 1; a*a + b1[a]*b1[a] < to; a++)
{
// a^2 + b^2
unsigned int b = b1[a];
for (; a*a + b*b < to; b++)
used[a*a + b*b - from] |= One;
b1[a] = b;
// a^2 + 2b^2
b = b2[a];
for (; a*a + 2*b*b < to; b++)
used[a*a + 2*b*b - from] |= Two;
b2[a] = b;
// a^2 + 3b^2
b = b3[a];
for (; a*a + 3*b*b < to; b++)
used[a*a + 3*b*b - from] |= Three;
b3[a] = b;
// a^2 + 7b^2
b = b7[a];
for (; a*a + 7*b*b < to; b++)
used[a*a + 7*b*b - from] |= Seven;
b7[a] = b;
}
// count all matching numbers
for (auto& x : used)
{
if (x == All)
count++;
// reset for next iteration
x = 0;
}
from = to;
}
std::cout << count << std::endl;
return 0;
}
This solution contains 15 empty lines, 14 comments and 3 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in 10.5 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
Peak memory usage was about 4 MByte.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
June 21, 2017 submitted solution
June 21, 2017 added comments
Difficulty
Project Euler ranks this problem at 70% (out of 100%).
Links
projecteuler.net/thread=229 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
Python github.com/hughdbrown/Project-Euler/blob/master/euler-229.py (written by Hugh Brown)
C++ github.com/Meng-Gen/ProjectEuler/blob/master/229.cc (written by Meng-Gen Tsai)
C++ github.com/roosephu/project-euler/blob/master/229.cpp (written by Yuping Luo)
C github.com/LaurentMazare/ProjectEuler/blob/master/e229.c (written by Laurent Mazare)
Java github.com/thrap/project-euler/blob/master/src/Java/Problem229.java (written by Magnus Solheim Thrap)
Mathematica github.com/steve98654/ProjectEuler/blob/master/229.nb
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own. Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 227 - The Chase | Fibonacci Words - problem 230 >> |